﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MontoyaTech.MySqlPlus
{
    /// <summary>
    /// The outline of a MySqlColumnConverter that can convert a
    /// columns value from one type to another and back.
    /// </summary>
    public interface MySqlColumnConverter
    {
        /// <summary>
        /// Converts the input value to the desired type the database expects.
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        object ConvertTo(object input);

        /// <summary>
        /// Converts the input value from a database type to the desired type.
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        object ConvertFrom(object input);

        /// <summary>
        /// Returns the MySql Column Type that this converter converts that data into.
        /// </summary>
        string ConvertToType { get; }
    }
}
